﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
um einen InnerJoin zu generieren brauchts nur die PrimColumn der übergeordneten und die ForeignKey-Column der untergeordneten Table. Kurz: Die DataRelation zw. den beiden. Minimum: die ForeignKey-Column, denn damit läßt sich die DataRelation finden.
Joiner ist nun eine Liste of ColumnInfo-Pärchen (also DataRelations)
Das Zusammen-Joinen vieler Tables muss in geeigneter Reihenfolge geschehen, denn die On-Bedingung verknüpft immer eine der vorgenannten Tabellen mit der neu hinzukommenden.
Ist die neue Tabelle bereits aufgeführt, so liegt ein Self-Join vor, und die neue muß renamed werden.
Angenommen die Relationen Kunde->Bestellung<-Bearbeiter, Bestellung->BestellDetail.
Da braucht Joiner die 3 Relationen, und dann kann er die 4 Tabellen zusammenklatschen:
Bestellung INNER JOIN Kunde ON Kunde.ID=Bestellung.KundeID INNER JOIN Bearbeiter ON Bearbeiter.ID=Bestellung.BearbeiterID INNER JOIN BestellDetail ON BestellDetail.BestellungID=Bestellung.ID
Sinn hat das nur mit zusätzlichen Expressions, die eingearbeitet wern können. Etwa folgendes findet alle Bestellungen, BestellDetails und bestellte Artikel eines bestimmten Kunden:
Bestellung INNER JOIN BestellDetail ON (Bestellung.KundeID=? AND BestellDetail.BestellungID=Bestellung.ID) INNER JOIN Artikel ON Artikel.ID=BestellDetail.ArtikelID
#End If
' -------------- Imports & Options --------------------
Imports System.Runtime.CompilerServices
Imports System.ComponentModel
Imports System.Data.Common
Imports System.Text
Imports System.Collections.ObjectModel
#End Region 'FileHeader

Namespace System.Data

   Public Class Joiner : Inherits Collection(Of ColumnInfo())
      Private _Quote As Func(Of String, String)
      Protected Overrides Sub InsertItem(index As Integer, item() As ColumnInfo)
         MyBase.InsertItem(index, item)
      End Sub
      Public Function SelfJoin(col As DataColumn, xpr1 As String) As Joiner
         ' mit einem Self-Join kann über m:n die Zutreffen mehrerer Kategorien abfragen (logic-AND). Über den m-ForeignKey joint die mittlerTable sich selbst - das ergibt wieder sich selbst. Nun wird aber das Zusatz-Kriterium gestellt, dass der n-ForeignKey einen bestimmten wert aufweisen soll. Dadurch werden alle Zuordnungen zw. m und n gefunden. (Das ginge zunächstmal auch mit einer einfachen WHERE-Klausel, aber) bei  Self-Joins kann man das Ergebnis wieder self-joinen und jeweils über ein weiteres n-Kriterium weiter einschränken.
         MyBase.Add({New ColumnInfo(col, "", _Quote), New ColumnInfo(col, xpr1, _Quote)})
         Return Me
      End Function
      Public Shadows Function Add(colChild As DataColumn, Optional xpr1 As String = "") As Joiner
         Return Me.Add("", colChild, xpr1)
      End Function
      Public Shadows Function Add(rl As DataRelation, Optional xpr1 As String = "") As Joiner
         Return Me.Add("", rl, xpr1)
      End Function
      Public Shadows Function Add(xpr0 As String, colChild As DataColumn, Optional xpr1 As String = "") As Joiner
         Dim rl = colChild.Table.ParentRelations.Cast(Of DataRelation) _
            .First(Function(r) r.ChildColumns(0) Is colChild)
         Return Me.Add(xpr0, rl, xpr1)
      End Function
      Public Shadows Function Add(xpr0 As String, rl As DataRelation, Optional xpr1 As String = "") As Joiner
         If rl.ChildColumns.Length > 1 Then Throw Me.Exception("Joiner unterstützt keine mehrspaltigen DataRelations")
         MyBase.Add({New ColumnInfo(rl.ParentColumns(0), xpr0, _Quote), New ColumnInfo(rl.ChildColumns(0), xpr1, _Quote)})
         Return Me
      End Function

      Public Sub New(Optional quote As Func(Of String, String) = Nothing)
         _Quote = quote
      End Sub

      Public Function Sql() As String
         If Count = 0 Then Return ""
         'joinedTables enthält die Tables, auf die ein InnerJoin sich beziehen kann, und dient der Erkennung von Self-Joins, bei denen eine Table umbenannt wern muss.
         Dim joinedTables = New HashSet(Of DataTable) From {Me(0)(0).Table}
         Dim EnsureJoinableColumnInfoPair As Action(Of Integer) = _
            Sub(iCurrent As Integer)
               'ggfs. durch Swap gewährleisten, dass an iCurrent ein ColumnInfo-Pair ist, dessen erste Table in joinedTables aufgeführt ist. Dieses weil die Sql-InnerJoin-Klausel sich auf eine zuvor genannte Tabelle beziehen muss.
               For iTest = iCurrent To Count - 1
                  Dim ColumnInfoPair = Me(iTest)
                  For i = 0 To 1
                     If joinedTables.Contains(ColumnInfoPair(0).Table) Then
                        If iTest > iCurrent Then Swap(iTest, iCurrent)
                        Return
                     End If
                     ColumnInfoPair.Swap(0, 1)
                  Next
               Next
               Throw GetType(Joiner).Exception("can't find joinable dataRelation")
            End Sub

         Dim sqlParts = {New String("("c, Count), Me(0)(0).TableName}.ToList
         Dim counter As Counter = 0
         For i = 0 To Count - 1
            EnsureJoinableColumnInfoPair(i)
            Dim ColumnInfoPair = Me(i), toJoin = ColumnInfoPair(1)
            Dim joinedTableName = If(joinedTables.Add(toJoin.Table), toJoin.TableName, toJoin.RenameTable("X" & counter.Up))
            sqlParts.Add(" INNER JOIN ", joinedTableName, " ON (")
            For Each colInf In ColumnInfoPair.Where(Function(ci) "" <> ci.Expression)
               sqlParts.Add(colInf.TableName, ".", colInf.Expression.Trim, " AND ")
            Next
            sqlParts.Add(ColumnInfoPair(0).Fullname, "=", toJoin.Fullname, "))") 'Columns joinen
         Next
         Return String.Concat(sqlParts)
      End Function

   End Class

End Namespace
