﻿Imports System.IO
Imports ICaSE.Modul_Allgemein

Public Class Arbeitsliste_kurz


    Private Sub bHilfe_Click(sender As Object, e As EventArgs) Handles bHilfe.Click
        MsgBox("Diese Liste dient der Verifizierung der Intervallkarzinome." + vbCrLf + "Außerdem können Sie die Fälle den Standorten zuordnen.")
    End Sub

    Private Sub bSchließen_Click(sender As Object, e As EventArgs) Handles bSchließen.Click
        Me.Close()
    End Sub

#Region "allgemein verwendbare Funktionalität"

    Private Sub Save()
        Me.Validate() 'übernimmt ggfs. die aktuelle Eingabe, auch wenn noch nicht abgeschlossen. Andernfalls wundert man sich womöglich, dass die letzte Eingabe nicht mit abgespeichert wurde
        Start.ICaDataSet.WriteXml(Start.ICaDataSetFile)
        Start.ICaDataSet.AcceptChanges() 'setzt Dataset.HasChanges auf False. Das hat auswirkungen auf das Schließ-Verhalten in Form_FormClosing 
        Media.SystemSounds.Asterisk.Play()

        Start.TextBoxLog.Text = "ICaDataSet gespeichert in: " & Start.ICaDataSetFile & vbCrLf & Start.TextBoxLog.Text

    End Sub

    Private Sub Reload()
        Start.ICaDataSet.Clear()

        For Each tb As DataTable In Start.ICaDataSet.Tables
            tb.BeginLoadData() 'deaktiviert während des Ladens AktualisierungsVorgänge des Databindings
        Next
        Start.ICaDataSet.ReadXml(Start.ICaDataSetFile)
        For Each tb As DataTable In Start.ICaDataSet.Tables
            tb.EndLoadData()
        Next
        Start.ICaDataSet.EnforceConstraints = True 'tb.BeginLoadData setzt autom. EnforceConstraints.False - also zurücksetzen
        Start.ICaDataSet.AcceptChanges()
    End Sub

    Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles Me.FormClosing
        ' Me.KundenBindingSource.EndEdit()
        If Not Start.ICaDataSet.HasChanges Then Return 'liegen keine Änderungen vor, wird auch nix gespeichert
        If e.Cancel Then Return '                 ist Canceln bereits vorgemerkt ist, wird auch nix gespeichert
        Select Case MessageBox.Show(Me, "Änderungen speichern?", "Formular schließen", MessageBoxButtons.YesNoCancel)
            Case DialogResult.No             'nix tun: schließen ohne speichern
            Case DialogResult.Yes : Save()                ' schließen mit speichern
            Case DialogResult.Cancel : e.Cancel = True         'Schließung canceln
        End Select
    End Sub
    'Korrektur eines WinForm-Bugs
    Private Sub frmPhonebook_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
        Me.Validate() 'nochn Bug: DGV kriegt beim Disposen einen ZeilenIndex-Fehler, wenn sich die ZufügeZeile im Edit-Modus befindet
        Me.SuspendLayout()
        With Me.Controls
            'Controls könnten sich theor. auch gegenseitig disposen, über Events. dieses hier disposed ganz sicher immer das letzte Element was noch da ist
            While .Count > 0 : .Item(.Count - 1).Dispose() : End While
        End With
    End Sub

    Private Sub DataGridView1_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DataGridView1.CellClick
        ' Welche Zeile wurde geklickt? Das reicht, denn dann habe ich die Id_ICa
        Dim rowICa As ICaDataSet.ICaRow = DirectCast(DirectCast(ICaBindingSource.Current, DataRowView).Row, ICaDataSet.ICaRow)
        'Console.WriteLine("Geklickt wurde für kommNr " & rowICa.kommNr & " in Spalte mit Index " & e.ColumnIndex.ToString)

        ' 9:Ja, 10:Nein, 11:Abbruch, 12:Parken
        ' If e.ColumnIndex < 9 Or e.ColumnIndex > 12 Then Exit Sub

        Select Case e.ColumnIndex
            Case DataGridView1.Columns("Ja").Index
                ICaBindingSource.Current("ICaTyp") = "Ja"

                ' Use ICaStatus Bit 0 löschen
                ICaBindingSource.Current("ICaStatus") = BitLöschen(ICaBindingSource.Current("ICaStatus"), 0)

                ' Use ICaStatus Bit 1 Wert 2 setzen
                ICaBindingSource.Current("ICaStatus") = BitSetzen(ICaBindingSource.Current("ICaStatus"), 1)

            Case DataGridView1.Columns("Nein").Index
                Dim erg As Object
                erg = InputBox("Warum ist das hier KEIN Intervallkarzinom?", "Bemerkung", NullIf(ICaBindingSource.Current("Bemerkung"), ""))
                If Not erg = "" Then
                    ICaBindingSource.Current("ICaTyp") = "Nein"
                    ICaBindingSource.Current("Bemerkung") = erg

                    ' Use ICaStatus Bit 0 löschen
                    ICaBindingSource.Current("ICaStatus") = BitLöschen(ICaBindingSource.Current("ICaStatus"), 0)

                    ' Use ICaStatus Bit 1 Wert 2 setzen
                    ICaBindingSource.Current("ICaStatus") = BitSetzen(ICaBindingSource.Current("ICaStatus"), 1)

                End If

            Case DataGridView1.Columns("Abbruch").Index
                ICaBindingSource.Current("ICaTyp") = "Abbruch"

                ' Use ICaStatus Bit 0 Wert 1 löschen
                ICaBindingSource.Current("ICaStatus") = BitLöschen(ICaBindingSource.Current("ICaStatus"), 0)
                ' Use ICaStatus Bit 1 Wert 2 setzen
                ICaBindingSource.Current("ICaStatus") = BitSetzen(ICaBindingSource.Current("ICaStatus"), 1)

            Case DataGridView1.Columns("Parken").Index
                ICaBindingSource.Current("ICaTyp") = "Ja"

                Dim erg As Object
                ' Use ICaStatus Bit 0 prüfen, ggfs. löschen
                If BitPrüfen(ICaBindingSource.Current("ICaStatus"), 0) = True Then
                    If MsgBox(NullIf(ICaBindingSource.Current("Bemerkung"), ""), vbQuestion + vbYesNo, "Fall freigeben?") = vbYes Then ICaBindingSource.Current("ICaStatus") = BitLöschen(ICaBindingSource.Current("ICaStatus"), 0)
                Else
                    erg = InputBox("Aufgrund welcher Besonderheiten stellen Sie den Fall zurück?", "Bemerkung", NullIf(ICaBindingSource.Current("Bemerkung"), ""))
                    If Not erg = "" Then
                        ICaBindingSource.Current("Bemerkung") = erg
                        ' Use ICaStatus Bit 0 Wert 1 setzen
                        ICaBindingSource.Current("ICaStatus") = BitSetzen(ICaBindingSource.Current("ICaStatus"), 0)
                    End If
                End If

            Case Else
                Exit Sub
        End Select

        Me.Refresh()
        ' DataGridView1.Refresh()

    End Sub

    Private Sub Arbeitsliste_kurz_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        ' auch hier, umbiegen der BindingSource zur Laufzeit
        ICaBindingSource.DataSource = Start.ICaDataSet
        ICaBindingSource.DataMember = "ICa"
        StandortBindingSource.DataSource = Start.ICaDataSet
        StandortBindingSource.DataMember = "Standort"
    End Sub

    Private Sub DataGridView1_ColumnHeaderMouseClick(sender As Object, e As DataGridViewCellMouseEventArgs) Handles DataGridView1.ColumnHeaderMouseClick

        ' Wie breit ist die Column gerade?
        Console.WriteLine("Spaltenbreite: " & DataGridView1.Columns(e.ColumnIndex).Width)


    End Sub
#End Region 'allgemein verwendbare Funktionalität

End Class