﻿Imports System.IO

Public Class Start

    Public ICaDataSetFile As String = Application.StartupPath() & "\ICaDataSet.xml"

    Private Sub bHilfe_Click(sender As Object, e As EventArgs) Handles bHilfe.Click
        Dim m As String
        m = "Verwaltung und Beurteilung von Intervallkarzinomen in der Screeningeinheit"
        m = m & vbCrLf & "Bitte führen Sie die Konfiguration im Administrationsformular durch."
        MsgBox(m, vbOKOnly, "Hilfe Startformular")

    End Sub

    Private Sub bSchließen_Click(sender As Object, e As EventArgs) Handles bSchließen.Click
        Me.Close()
    End Sub

    Private Sub bArbeitsliste_kurz_Click(sender As Object, e As EventArgs) Handles bArbeitsliste_kurz.Click

        Dim tb = ICaDataSet.ICa
        If tb.Rows.Count < 1 Then
            MsgBox("Es sind keine Daten vorhanden. Bitte importieren Sie zunächst eine DS02 Datei mit Kommunikationsnummern.")
            Exit Sub
        End If

        Arbeitsliste_kurz.Show()

    End Sub

    Private Sub bImportDS02_Click(sender As Object, e As EventArgs) Handles bImportDS02.Click

        ' DS02 Verzeichnis aus config holen
        'MsgBox("Ohne Adminformular ist das DS02 Import Verzeichnis im Code fest verdrahtet.")
        OpenFileDialogDS02.InitialDirectory = "O:\ICa\ICa_SE\DS02_Import\"

        ' Verzeichnisselektor 
        If OpenFileDialogDS02.ShowDialog() = System.Windows.Forms.DialogResult.OK Then

            ' Datei in OpenFileDialogDS02.FileName
            TextBoxLog.Text = "Lade DS02 Datei " & OpenFileDialogDS02.FileName & vbCrLf & TextBoxLog.Text

            ' XML laden. Da wir aus der XSD Datei ein DataSet generieren ließen, können wir die XML dort direkt hineinsaugen
            DataSetDS02.Clear()
            DataSetDS02.ReadXml(OpenFileDialogDS02.FileName)


            ' Übertrage die Daten aus DataSetDS02 nach ICaDataset 
            Dim DS02Row As DataSetDS02.DS02Row
            Dim DS02_ivcaRow As DataSetDS02.DS02_ivcaRow
            Dim DS02_melderRow As DataSetDS02.DS02_melderRow

            Dim ICaRow As ICaDataSet.ICaRow
            Dim metadataRow As ICaDataSet.metadataRow
            Dim MelderRow As ICaDataSet.MelderRow

            Dim AnzahlMelder As Int32 = 0         ' Zähler für Melder
            Dim AnzahlMelderGesamt As Int32 = 0   ' Melder gesamt für aktuelle kommNr
            Dim AnzahlICa As Int32 = 0            ' Zähler für ICa
            Dim AnzahlICaGesamt As Int32 = 0      ' ICa gesamt in Importdatei

            Dim neuICa As Boolean = True          ' Flag, ob es ein neuer Fall ist -> Ica_x_Melder
            Dim neuMelder As Boolean = True       ' Flag, ob es ein neuer Melder ist -> Ica_x_Melder

            Dim zeitraum As Int32
            'Console.WriteLine(DataSetDS02.Tables("DS02_data").Rows(0)("zeitraum"))
            '#' zeitraum = DataSetDS02.Tables("DS02_data").Rows(0)("zeitraum")
            zeitraum = DataSetDS02.DS02_data.Rows(0)("zeitraum")

            ' Siehe ObjectBrowser: das DataSet (ICaDataSet) hat Tabellen (metadata), die haben Methoden (NewRow-erzeugt ein Objekt für eine neue Zeile)
            metadataRow = ICaDataSet.metadata.NewRow()
            metadataRow.DSxx = "DS02"
            metadataRow.RZ = DataSetDS02.Tables("DS02_data").Rows(0)("RZ")
            metadataRow.SE = DataSetDS02.Tables("DS02_data").Rows(0)("SE")
            metadataRow.dateidatum = DataSetDS02.Tables("DS02_data").Rows(0)("dateidatum")
            metadataRow.zeitraum = zeitraum
            metadataRow.imexdatei = OpenFileDialogDS02.FileName
            metadataRow.imexdatum = FormatDateTime(Now, DateFormat.GeneralDate)

            ' Siehe ObjectBrowser: das DataSet (ICaDataSet) hat Tabellen (metadata), die haben Methoden (AddmetadataRow-fügt ein Zeilenobjekt der Tabelle hinzu)
            ICaDataSet.metadata.AddmetadataRow(metadataRow)

            TextBoxLog.Text = "Lade DS02 aus " & metadataRow.SE & " vom " & metadataRow.dateidatum & vbCrLf & TextBoxLog.Text



            'Dim ivcaJoin As DataRelation =
            '    DataSetDS02.Relations.Add("DS02_DS02_icva",
            '        DataSetDS02.Tables("DS02").Columns("DS02_Id"),
            '        DataSetDS02.Tables("DS02_ivca").Columns("DS02_Id"))
            '' Diese Relation gibt es bereits im DataSet und heißt "DS02_DS02_ivca"
            AnzahlICaGesamt = DataSetDS02.DS02.Count
            AnzahlMelderGesamt = DataSetDS02.DS02_melder.Count
            TextBoxLog.Text = "Lade " & AnzahlICaGesamt & " Fälle mit " & AnzahlMelderGesamt & " Melderadressen" & vbCrLf & TextBoxLog.Text

            ProgressBar1.Maximum = AnzahlICaGesamt
            ProgressBar1.Step = AnzahlICaGesamt
            ProgressBar1.Visible = True
            LabelProgressBar1.Text = "0/" & AnzahlICaGesamt.ToString
            LabelProgressBar1.Visible = True


            For Each DS02Row In DataSetDS02.DS02.Rows
                AnzahlICa += 1
                ' ---------------------------------------------------------------------------------------------
                ' zuerst ICaRow füllen 
                ' ---------------------------------------------------------------------------------------------
                ICaRow = ICaDataSet.ICa.NewRow()    ' neuer Datensatz oder ICaRow lädt einen vorhandenen

                ' gibt es den Fall schon? Dann Id holen
                Dim foundRows() As Data.DataRow
                foundRows = ICaDataSet.ICa.Select("kommNr= '" & DS02Row("kommNr") & "' AND zeitraum=" & zeitraum.ToString)
                If foundRows.Count = 0 Then
                    '' !!! Auskommentiert, da die Id ein Autoinkrement ist 
                    '' neuer Fall (kommNr)
                    'If ICaDataSet.ICa.Count > 0 Then ' und nicht der erste
                    '    Id_ICa = ICaDataSet.ICa.Compute("Max(Id_ICa)", "") + 1
                    'Else    ' der erste Fall überhaupt
                    '    Id_ICa = 1
                    'End If
                    ICaRow.kommNr = DS02Row("kommNr")
                    'ICaRow("zeitraum") = DS02Row.GetParentRow("DS02_data_DS02")("zeitraum") ' hole aus der übergeordneten Tabelle den zeitraum
                    ICaRow.zeitraum = zeitraum ' oder nimm einfach die zuvor definierte Variable ;)
                    ICaRow.ICaStatus = 0 ' hierfür muss noch eine Set-Methode eingebaut werden

                    ' DS02_ivca: genau ein Datensatz! Es gibt aber im DataSet keine 1:1 Beziehung, weshalb es nur .GetChildRows statt .GetChildRow gibt!
                    For Each DS02_ivcaRow In DS02Row.GetChildRows("DS02_DS02_ivca") ' Name einer Relation als String oder eine Relation an sich, wie zuvor definiert
                        ICaRow.ivca_Abgleichqualitaet = DS02_ivcaRow.ivca_Abgleichqualitaet.ToString()
                        ICaRow.ivca_DiagnoseJahr = DS02_ivcaRow.ivca_DiagnoseJahr.ToString()
                        ICaRow.ivca_DiagnoseMonat = DS02_ivcaRow.ivca_DiagnoseMonat.ToString()
                        If ICaRow.ivca_DiagnoseMonat = 0 Then ICaRow.ivca_DiagnoseMonat = 1

                    Next ' DS02_ivca
                    ' erst jetzt, weil ICa_x_Melder befüllt sein muss
                    'ICaRow.Id_ICa = Id_ICa  ' ne, autoinkrement
                    ICaDataSet.ICa.AddICaRow(ICaRow) ' ne, siehe später -> Scheiße, nein, muss doch zuerst gemacht werden
                    'Console.WriteLine("(" & ICaRow.Id_ICa.ToString & ") " & ICaRow.kommNr & " in ICaDataSet.ICa eingefügt")
                Else
                    ' es gibt die kommNr, also zugehörige Id_ICa auslesen
                    'Id_ICa = foundRows(0)("Id_ICa")    ' ne, ganze Row lesen
                    ICaRow = foundRows(0)               ' die Row, es gibt nur eine, zuweisen
                    neuICa = False
                End If
                ' ICaRow ist nun befüllt. Entweder mit neuen Daten oder mit ausgelesenen, weil die kommNr schon existiert
                ' ---------------------------------------------------------------------------------------------

                ' ---------------------------------------------------------------------------------------------
                ' jetzt MelderRow(s) füllen 
                ' ---------------------------------------------------------------------------------------------
                ' DS02_melder, es gibt >=1 pro ICaRow

                AnzahlMelderGesamt = DS02Row.GetChildRows("DS02_DS02_melder").Count

                For Each DS02_melderRow In DS02Row.GetChildRows("DS02_DS02_melder")
                    AnzahlMelder += 1
                    MelderRow = ICaDataSet.Melder.NewRow()     ' neuer Datensatz oder ICaRow lädt einen vorhandenen

                    ' Gibt es den Melder bereits? Suche die zusammengebaute ID in ICaDataSet.Melder
                    'melder_Id = DS02_melderRow("melder_Nachname").ToString() + DS02_melderRow("melder_Vorname").ToString() + DS02_melderRow("melder_Plz").ToString()
                    'melder_Id = DS02_melderRow.melder_Id
                    foundRows = ICaDataSet.Melder.Select("melder_Id = '" & DS02_melderRow.melder_Id & "'")
                    If foundRows.Count = 0 Then
                        '' !!! Auskommentiert, da die Id ein Autoinkrement ist 
                        '' es ist ein neuer Melder
                        '' neuen Datensatz in ICa_x_Melder (kommNr und Id)
                        '' max(Id) ermitteln und einen draufsetzen
                        'If ICaDataSet.Melder.Count > 0 Then
                        '    Id_Melder = ICaDataSet.Melder.Compute("Max(Id_Melder)", "") + 1
                        'Else
                        '    Id_Melder = 1
                        'End If

                        'Console.WriteLine(DS02_melderRow("melder_Nachname").ToString() + ", " + DS02_melderRow("melder_Vorname").ToString() + ", " + DS02_melderRow("melder_Ort").ToString())
                        'MelderRow.Id_Melder = Id_Melder    ' ne, autoinkrement
                        MelderRow.melder_Nachname = DS02_melderRow.melder_Nachname.ToString()
                        MelderRow.melder_Vorname = DS02_melderRow.melder_Vorname.ToString()
                        MelderRow.melder_Titel = DS02_melderRow.melder_Titel.ToString()
                        MelderRow.melder_Institution = DS02_melderRow.melder_Institution.ToString()
                        MelderRow.melder_Abteilung = DS02_melderRow.melder_Abteilung.ToString()
                        MelderRow.melder_Strasse = DS02_melderRow.melder_Strasse.ToString()
                        MelderRow.melder_Plz = DS02_melderRow.melder_Plz.ToString()
                        MelderRow.melder_Ort = DS02_melderRow.melder_Ort.ToString()
                        MelderRow.melder_Type = DS02_melderRow.melder_Type.ToString()
                        ICaDataSet.Melder.AddMelderRow(MelderRow)  ' ne, folgt später "magisch" -> Scheiße, nein, muss doch zuerst gemacht werden
                        'Console.WriteLine("Melder " & MelderRow.Id_Melder.ToString & " in ICa.Melder eingefügt: " & MelderRow.melder_Nachname)

                    Else
                        ' es gibt den Melder, also zugehörige Id_Melder auslesen
                        'Id_Melder = foundRows(0)("Id_Melder")  ' ne, ganze Row lesen
                        MelderRow = foundRows(0)                ' die Row, es gibt nur eine, zuweisen
                        neuMelder = False
                    End If ' neuer Melder


                    ' ICa_x_Melder anlegen: Childtable, also zuerst Melder und ICa anlegen!

                    'If neuMelder Or neuICa Then    ' kein "If Then End If", da dieser x immer angelegt wird. Falls bereits vorhanden, passiert ja nichts
                    ICaDataSet.ICa_x_Melder.AddICa_x_MelderRow(ICaRow, MelderRow)
                    'End If

                Next 'DS02_melder

                'Console.WriteLine("Fall " & AnzahlICa & "/" & AnzahlICaGesamt & " mit " & AnzahlMelderGesamt & " Meldern")
                'TextBoxLog.Text = "Fall " & AnzahlICa & "/" & AnzahlICaGesamt & " mit " & AnzahlMelderGesamt & " Meldern" & vbCrLf & TextBoxLog.Text
                ProgressBar1.PerformStep()
                LabelProgressBar1.Text = AnzahlICa.ToString & "/" & AnzahlICaGesamt.ToString

            Next ' DS02: alle kommNr

            '' Schema im Log anzeigen
            'Dim StringWriterXML As New System.IO.StringWriter()
            'DataSetDS02.WriteXmlSchema(StringWriterXML)
            'TextBoxLog.Text = "Schema der DS02-Datei: " & vbCrLf & StringWriterXML.ToString & vbCrLf & vbCrLf & TextBoxLog.Text

            TextBoxLog.Text = "Fertig!" & vbCrLf & TextBoxLog.Text
            ProgressBar1.Visible = False
            LabelProgressBar1.Visible = False

        End If

    End Sub

    Private Sub Start_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown

        Me.TextBoxLog.Text = "Programm gestartet aus " & Application.StartupPath()

    End Sub

    Private Sub bDataSetBetrachter_Click(sender As Object, e As EventArgs) Handles bDataSetBetrachter.Click

        DataSetBetrachter.Show()

    End Sub

    Private Sub Save()

        ' Verzeichnisselektor 
        SaveFileDialog1.InitialDirectory = Application.StartupPath().ToString
        SaveFileDialog1.Filter = "XML Datei (*.xml)|*.xml|All files (*.*)|*.*"
        If SaveFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Me.Validate() 'übernimmt ggfs. die aktuelle Eingabe, auch wenn noch nicht abgeschlossen. Andernfalls wundert man sich womöglich, dass die letzte Eingabe nicht mit abgespeichert wurde
            ICaDataSet.WriteXml(SaveFileDialog1.FileName)
            ICaDataSet.AcceptChanges() 'setzt Dataset.HasChanges auf False. Das hat auswirkungen auf das Schließ-Verhalten in Form_FormClosing 
            Media.SystemSounds.Asterisk.Play()
            MsgBox("Das ICaDataSet wurde in dieser XML-Datei gespeichert:" + vbCrLf + SaveFileDialog1.FileName, vbOKOnly, "ICaDataSet speichern")
            ICaDataSetFile = SaveFileDialog1.FileName

            Me.TextBoxLog.Text = "ICaDataSet gespeichert in: " & SaveFileDialog1.FileName & vbCrLf & Me.TextBoxLog.Text
        End If
    End Sub

    Private Sub Reload()

        ' Verzeichnisselektor 
        OpenFileDialog1.InitialDirectory = Application.StartupPath().ToString
        OpenFileDialog1.Filter = "XML Datei (*.xml)|*.xml|All files (*.*)|*.*"

        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            ICaDataSet.Clear()

            For Each tb As DataTable In ICaDataSet.Tables
                tb.BeginLoadData() 'deaktiviert während des Ladens AktualisierungsVorgänge des Databindings
            Next
            ICaDataSet.ReadXml(OpenFileDialog1.FileName)
            For Each tb As DataTable In ICaDataSet.Tables
                tb.EndLoadData()
            Next
            ICaDataSet.EnforceConstraints = True 'tb.BeginLoadData setzt autom. EnforceConstraints.False - also zurücksetzen
            ICaDataSet.AcceptChanges()

            Me.TextBoxLog.Text = "ICaDataSet geladen aus: " & OpenFileDialog1.FileName & vbCrLf & Me.TextBoxLog.Text

        End If

    End Sub

    Private Sub bICaLaden_Click(sender As Object, e As EventArgs) Handles bICaLaden.Click

        If MsgBox("Achtung!" & vbCrLf & "Das ICa-DataSet wird von einer gespeicherten Version geladen, egal, was gerade an DSxx etc. importiert wurde.", vbYesNoCancel, "ICaDataSet laden") = vbYes Then
            Reload()
        End If

    End Sub

    Private Sub bICaSpeichern_Click(sender As Object, e As EventArgs) Handles bICaSpeichern.Click
        Save()

    End Sub
End Class