﻿Imports System.Drawing
Imports System.ComponentModel
Namespace System.Windows.Forms

   <DefaultEvent("CheckedChanged")> _
   <System.ComponentModel.DesignerCategory("Code")> _
   Public Class CheckMenu : Inherits ToolStripMenuItem

      ' Shared Images: alle CheckMenu-Objekte greifen auf **dieselben** Images zu, statt sich je
      ' eigene zu erzeugen
      Private Shared _Images As Image()

      Shared Sub New()
         ' Untiger ComponentResourceManager arbeitet auf der lokalen Ressource "Checkmenu.resx".
         ' Um eine lokale Ressource-Datei zu erzeugen muß zunächst von Component geerbt werden
         ' (hier: mittelbar über ToolStripMenuItem). 
         ' Dann in die Designer-Ansicht von CheckMenu gehen, ein beliebiges Item aus der Toolbox
         ' hinzufügen, und wieder löschen.
         ' Im Projekt-Explorer "Alle Dateien anzeigen" aktivieren, CheckMenu-Knoten erweitern, und
         ' Checkmenu.resx mit Doppelklick öffnen. Jetzt können Bilder zugefügt werden. 
         ' Sinn der lokalen Bildressource ist, daß CheckMenu seine Bilder "mitnimmt", wenn es in
         ' andere Projekte kopiert wird.
         With New ComponentResourceManager(GetType(CheckMenu))
            _Images = New Image() { _
               CType(.GetObject("UnChecked"), Image), CType(.GetObject("Checked"), Image)}
         End With
      End Sub

      Public Sub New()
         MyBase.New()
         Me.Image = _Images(0)
         MyBase.CheckOnClick = True
      End Sub

      Protected Overrides Sub OnCheckedChanged(ByVal e As System.EventArgs)
         MyBase.OnCheckedChanged(e)
         Me.Image = _Images(-CInt(MyBase.Checked))
      End Sub

      <DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
      Public Overrides Property Image() As System.Drawing.Image
         Get
            Return MyBase.Image
         End Get
         Set(ByVal value As System.Drawing.Image)
            MyBase.Image = value
         End Set
      End Property

   End Class
End Namespace
