Imports System.ComponentModel
Namespace System.Windows.Forms

   Public Class BusyDelay

      Private _IsActive As Boolean

      Public Event BeforeBusyEnds As EventHandler

      ''' <summary> (de-)aktiviert das Warten auf den Eintritt in die Leerlauf-Warteschleife. </summary>
      ''' <remarks>Mehrfachaufrufe werden ignoriert</remarks>
      Public Sub SetRunning(ByVal Value As Boolean)
         If _IsActive = Value Then Return
         _IsActive = Value
         If _IsActive Then
            AddHandler Application.Idle, AddressOf Application_Idle
         Else
            RemoveHandler Application.Idle, AddressOf Application_Idle
         End If
      End Sub

      Private Sub Application_Idle(ByVal sender As Object, ByVal e As EventArgs)
         RemoveHandler Application.Idle, AddressOf Application_Idle
         _IsActive = False
         RaiseEvent BeforeBusyEnds(Me, e)
      End Sub


      Private Shared Sub BusyDelayCore_BeforeBusyEnds(ByVal sender As Object, ByVal e As EventArgs)
         If _MultiCallback.Null Then Return
         Dim act = DirectCast(_MultiCallback, Action)
         _MultiCallback = Nothing
         act()
      End Sub

      Private Shared _MultiCallback As [Delegate]

      Public Shared Sub SetCallback(ByVal cb As Action)
         _MultiCallback = [Delegate].Remove(_MultiCallback, cb)
         _MultiCallback = [Delegate].Combine(_MultiCallback, cb)
      End Sub
      Public Shared Sub RemoveCallback(ByVal cb As Action)
         _MultiCallback = [Delegate].Remove(_MultiCallback, cb)
      End Sub
      Shared Sub New()
         AddHandler Application.Idle, AddressOf BusyDelayCore_BeforeBusyEnds
      End Sub

   End Class 'BusyDelay

End Namespace


'Imports ComponentModel
'
'Public Class BusyDelay
'
'   Private WithEvents _DelayCore As BusyDelayCore = BusyDelayCore.Singleton
'   Private _IsActive As Boolean
'
'   Public Event BeforeBusyEnds As EventHandler
'
'   ''' <summary> (de-)aktiviert das Warten auf den Eintritt in die Leerlauf-Warteschleife. </summary>
'   ''' <remarks>Mehrfachaufrufe werden ignoriert</remarks>
'   Public Sub SetRunning(ByVal Value As Boolean)
'      _IsActive = Value
'      If _IsActive Then _DelayCore.StartDelay()
'   End Sub
'
'   Private Sub _DelayCore_BeforeBusyEnds(ByVal sender As Object, ByVal e As EventArgs) _
'         Handles _DelayCore.BeforeBusyEnds
'      If _IsActive Then
'         _IsActive = False
'         RaiseEvent BeforeBusyEnds(Me, e)
'      End If
'   End Sub
'
'   Private Shared Sub BusyDelayCore_BeforeBusyEnds(ByVal sender As Object, ByVal e As EventArgs)
'      Dim T2 As New List(Of Action)(_Targets)
'      _Targets.Clear()
'      If MyDesignMode.True Then
'         Try
'            For Each Mtd As Action In T2
'               Mtd()
'            Next
'         Catch ex As Exception
'            messagebox.show(ex.ToString)
'         End Try
'      Else
'         For Each Mtd As Action In T2
'            Mtd()
'         Next
'      End If
'   End Sub
'
'   'Private Shared Sub BusyDelayCore_BeforeBusyEnds(ByVal sender As Object, ByVal e As EventArgs)
'   '      Dim T2 As New List(Of Action)(_Targets)
'   '      For Each Mtd As Action In _Targets
'   '         Mtd()
'   '      Next
'   '      _Targets.Clear()
'   '   End Sub
'
'   Private Shared Function InitCallback() As List(Of Action)
'      InitCallback = New List(Of Action)
'      AddHandler BusyDelayCore.Singleton.BeforeBusyEnds, AddressOf BusyDelayCore_BeforeBusyEnds
'   End Function
'   Private Shared ReadOnly _Targets As List(Of Action) = InitCallback()
'   Public Shared Sub Callback(ByVal Dlg As Action)
'      With _Targets
'         If Not .Contains(Dlg) Then .Add(Dlg)
'      End With
'      BusyDelayCore.Singleton.StartDelay()
'   End Sub
'   Public Shared Sub AbortCallback(ByVal Dlg As Action)
'      With _Targets
'         If .Contains(Dlg) Then .Remove(Dlg)
'      End With
'   End Sub
'
'   ''' <summary>
'   ''' sendet sich selbst eine WindowMessage, und meldet, wann sie angekommen ist.
'   ''' So kann man ermitteln, wann die Anwendung wieder bereit ist, Events zu verarbeiten, 
'   ''' bzw. wann die Verarbeitung eines Ereignisses abgeschlossen ist.
'   ''' </summary>
'   ''' <remarks>Singleton</remarks>
'   Private Class BusyDelayCore : Inherits NativeWindow
'
'      Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
'         (ByVal hWnd As IntPtr, ByVal wMsg As Integer, ByVal wParam As Integer, _
'          ByVal lParam As Integer) As Integer
'
'      Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" _
'         (ByVal hWnd As IntPtr, ByVal wMsg As Integer, ByVal wParam As Integer, _
'          ByVal lParam As Integer) As Integer
'
'      'Ahaaa! SendMessage wandert direkt und synchron in die WndProc. PostMessage stellt sich
'      '! ordentlich in den WindowMessage-Queue, und kommt erst als WndProc heraus, wenn's dem
'      '! Betriebssystem genehm ist.
'
'      Public Event BeforeBusyEnds As EventHandler
'
'      Public Shared ReadOnly Singleton As New BusyDelayCore
'      Private _IsRunning As Boolean
'
'      Const WM_NOTIFY As Integer = &H4E
'
'      Private Sub New()
'         MyBase.CreateHandle(New CreateParams)
'      End Sub
'
'      ''' <summary> Aktiviert das Warten auf den Eintritt in die Leerlauf-Warteschleife. </summary>
'      ''' <remarks>Mehrfachaufrufe werden ignoriert</remarks>
'      Public Sub StartDelay()
'         If _IsRunning Then Return
'         _IsRunning = True
'         PostMessage(MyBase.Handle, WM_NOTIFY, 0, 0)
'      End Sub
'
'      Protected Overrides Sub WndProc(ByRef m As Message)
'         MyBase.WndProc(m)
'         If m.Msg = WM_NOTIFY Then
'            _IsRunning = False
'            RaiseEvent BeforeBusyEnds(Me, EventArgs.Empty)
'         End If
'      End Sub
'
'   End Class 'BusyDelayCore
'
'End Class 'BusyDelay
