﻿Imports System.Runtime.CompilerServices

Namespace System.Windows.Forms

   Public Module ControlX
#Region "DataGridView"
      ''' <summary> returns null if invalid rowIndex </summary>
      <Extension()> _
      Public Function DataRow(Of T As DataRow)(grd As DataGridView, rowIndex As Integer) As T
         If rowIndex < 0 Then Return Nothing
         Dim itm = DirectCast(grd.Rows(rowIndex).DataBoundItem, DataRowView)
         Return If(itm.Null, Nothing, DirectCast(itm.Row, T))
      End Function
      ''' <summary> returns null if invalid rowIndex </summary>
      <Extension()> _
      Public Function DataRow(grd As DataGridView, rowIndex As Integer) As DataRow
         If rowIndex < 0 Then Return Nothing
         Dim itm = DirectCast(grd.Rows(rowIndex).DataBoundItem, DataRowView)
         Return If(itm.Null, Nothing, itm.Row)
      End Function

      <Extension()> _
      Public Function Column(grd As DataGridView, dataColumn As DataColumn) As DataGridViewColumn
         Return grd.ColumnsX(dataColumn).First
      End Function
      <Extension()> _
      Public Function ColumnsX(grd As DataGridView, dataColumn As DataColumn) As IEnumerable(Of DataGridViewColumn)
         Return grd.Columns.Cast(Of DataGridViewColumn).Where(Function(col) col.DataPropertyName = dataColumn.ColumnName)
      End Function
#End Region 'DataGridView

#Region "TabControl"
      ''' <summary>
      ''' Dieser Schwachsinn im Form_Load ausgeführt behebt einen Bug beim DataBinding auf beim Start nicht sichtbaren Tabpages.
      ''' </summary>
      <Extension()> _
      Public Sub InitBindability(tc As TabControl)
         Dim parent = tc.FindForm
         parent.SuspendLayout()
         For Each tp As TabPage In tc.TabPages
            tp.SuspendLayout()
            For Each ctl In tp.Controls.Cast(Of Control).ToArray
               parent.Controls.Add(ctl)
               tp.Controls.Add(ctl)
            Next
            tp.ResumeLayout()
         Next
         parent.ResumeLayout()
      End Sub

      ''' <summary>hides Riders of TabControl</summary>
      <Extension()> _
      Public Sub HideRiders(tc As TabControl)
         tc.SuspendLayout()
         tc.SizeMode = TabSizeMode.Fixed
         tc.ItemSize = New Size(0, 1)
         tc.Appearance = TabAppearance.Buttons
         tc.ResumeLayout()
      End Sub
#End Region 'TabControl

   End Module

End Namespace
